#include <Wire.h>
#include "bitmapdata.h"
#include "SSD1306.h"

SSD1306 ssd1306 ;

// ----------------------
// ----- セットアップ -----
// ----------------------
void setup() {
  Wire.begin( ) ;
  ssd1306.init() ;
}

void loop() {
  // --- LOGO
  ssd1306.cls( ) ;
  ssd1306.oledSendCommand(0xD3,16) ;  // 縦方向のオフセット
  ssd1306.oledBitImage(20 , 0 , 88 , 8, bitmapData); // Bitmap表示
  delay(2000) ;
  ssd1306.oledSendCommand(0xD3,0) ;  // 縦方向のオフセット

  // --- 7SEG
  ssd1306.cls( ) ;
  ssd1306.disp7SEG(  0 , 0 , 11 ) ;
  ssd1306.disp7SEG( 20 , 0 , 1 ) ;
  ssd1306.disp7SEG( 40 , 0 , 2 ) ;
  ssd1306.disp7SEG( 56 , 0 , 10 ) ;
  ssd1306.disp7SEG( 72 , 0 , 3 ) ;
  ssd1306.disp7SEG( 92 , 0 , 12 ) ;

  ssd1306.disp7SEG(  0 , 4 , 13 ) ;
  ssd1306.disp7SEG( 20 , 4 , 4 ) ;
  ssd1306.disp7SEG( 40 , 4 , 5 ) ;
  ssd1306.disp7SEG( 60 , 4 , 14 ) ;

  // ----- V-OFFSET TEST ---
  for (int i=0;i<64;i++) {
    ssd1306.oledSendCommand(0xD3,i) ;  // 縦方向のオフセット
    delay(20) ;
  }
  ssd1306.oledSendCommand(0x40) ;      // 縦方向の描画開始位置 [40]
  ssd1306.oledSendCommand(0xD3,0) ;    // 縦方向のオフセット [00]
  // -----------------------
  delay(1000) ;

  // ----- V-OFFSET TEST ---
  ssd1306.oledSendCommand(0x2A, 0x00, 7, 7, 7, 1);
  ssd1306.oledSendCommand(0xA3, 11, 44);
  ssd1306.startScroll( ) ;
  delay(5000) ;
  ssd1306.stopScroll( ) ;
  // -----------------------

  // ----- H-SCROLL TEST ---
  // Continuous Horizontal Scroll Setup
  ssd1306.oledSetHorizontalScroll(0,0,3,7) ;
  ssd1306.startScroll( ) ;
  delay(5000) ;
//  ssd1306.oledSetHorizontalScroll(1,4,7,7) ;
//  ssd1306.startScroll( ) ;
//  delay(5000) ;
//  ssd1306.stopScroll( ) ;

  // --- 7SEG
  ssd1306.cls( ) ;
  ssd1306.disp7SEG(  0 , 0 , 11 ) ;
  ssd1306.disp7SEG( 20 , 0 , 1 ) ;
  ssd1306.disp7SEG( 40 , 0 , 2 ) ;
  ssd1306.disp7SEG( 56 , 0 , 10 ) ;
  ssd1306.disp7SEG( 72 , 0 , 3 ) ;
  ssd1306.disp7SEG( 92 , 0 , 12 ) ;

  ssd1306.disp7SEG(  0 , 4 , 13 ) ;
  ssd1306.disp7SEG( 20 , 4 , 4 ) ;
  ssd1306.disp7SEG( 40 , 4 , 5 ) ;
  ssd1306.disp7SEG( 60 , 4 , 14 ) ;

  // ----- HV-OFFSET TEST ---
  ssd1306.oledSendCommand(0xA3, 0, 64);
  // 0x00 , start page ,time interval ,end page , Vertical scrolling offset
  ssd1306.oledSendCommand(0x2A, 0x00, 0, 7 , 7, 1);
  ssd1306.startScroll( ) ;
  delay(5000) ;
  ssd1306.stopScroll( ) ;

  ssd1306.oledSetHorizontalVerticalScroll(1 , 0 , 7 , 7 , 0) ;
  ssd1306.startScroll( ) ;
  delay(5000) ;
  ssd1306.stopScroll( ) ;

  ssd1306.oledSetHorizontalVerticalScroll(0 , 0 , 7 , 7 , 1) ;
  ssd1306.startScroll( ) ;
  delay(5000) ;
  ssd1306.stopScroll( ) ;

  ssd1306.oledSendCommand(0x29, 0x00, 0, 7 , 7, 1);
  ssd1306.startScroll( ) ;
  delay(5000) ;
  ssd1306.stopScroll( ) ;
}
